const { resolve } = require('path');
const { parse } = require('vue-docgen-api');

module.exports = ({ componentsPath }) => ({
  async extendPageData($page) {
    const docgenPromises = ($page.frontmatter.components || [])
      .map(async component => {
        const documentJson = await parse(getComponentPath(component));

        return {
          name: component,
          ...documentJson,
        };
      });
    $page.componentDocuments = await Promise.all(docgenPromises);

    function getComponentPath(component) {
      const vFileName = component.includes('/')
        ? component // eg. button/button-group
        : `${component}/${component}` // eg. button

      return resolve(componentsPath, `${vFileName}.vue`);
    }
  },
});
